//=================================================================================================
// Constant buffers
//=================================================================================================

cbuffer cbMaterial
{
	float4 u_MaterialAmbientColor;
};

cbuffer cbObject
{
	matrix u_WorldViewProjectionMatrix;
};

//=================================================================================================
// Structures
//=================================================================================================

struct VS_IN
{
    float3 Position : POSITION;
};

struct PS_IN
{
    float4 Position : SV_POSITION;
};

struct PS_OUT
{
	float4 Color0   : SV_TARGET0;
	float4 Color1   : SV_TARGET1;
	float4 Color2   : SV_TARGET2;
	float4 Color3   : SV_TARGET3;
#if !defined(_WP8) && !defined(_WINRT_ARM)

	float4 Color4   : SV_TARGET4;
	float4 Color5   : SV_TARGET5;
	float4 Color6   : SV_TARGET6;
	float4 Color7   : SV_TARGET7;
#endif
	};

//=================================================================================================
// Vertex shader
//=================================================================================================

PS_IN vs_main(VS_IN In)
{
    PS_IN Out;
    Out.Position = mul(u_WorldViewProjectionMatrix, float4(In.Position, 1.0f));
    return Out;
}

//=================================================================================================
// Pixel shader
//=================================================================================================

PS_OUT ps_main(PS_IN In)
{
	PS_OUT Out;
	Out.Color0 = u_MaterialAmbientColor;
	Out.Color1 = u_MaterialAmbientColor;
	Out.Color2 = u_MaterialAmbientColor;
	Out.Color3 = u_MaterialAmbientColor;
#if !defined(_WP8) && !defined(_WINRT_ARM)
	Out.Color4 = u_MaterialAmbientColor;
	Out.Color5 = u_MaterialAmbientColor;
	Out.Color6 = u_MaterialAmbientColor;
	Out.Color7 = u_MaterialAmbientColor;
#endif	
	return Out;
}
