//=================================================================================================
// Samplers
//=================================================================================================

Texture2D u_MaterialDiffuseTexture;
SamplerState u_MaterialDiffuseTextureSampler;

//=================================================================================================
// Constant buffers
//=================================================================================================

cbuffer cbGlobal
{
	matrix u_WorldViewProjectionMatrix;
	float4 u_InnerColor;
};

//=================================================================================================
// Structures
//=================================================================================================

struct VS_IN
{
    float3 a_Position : POSITION;
    float2 a_TexCoord : TEXCOORD;
};

struct PS_IN
{
    float4 v_Position : SV_POSITION;
    float2 v_TexCoord : TEXCOORD;
    float4 v_FrontColor    : COLOR;
};

//=================================================================================================
// Vertex shader
//=================================================================================================

PS_IN vs_main(VS_IN In)
{
    PS_IN Out;
    Out.v_Position = mul(u_WorldViewProjectionMatrix, float4(In.a_Position, 1.0f));
    Out.v_TexCoord = In.a_TexCoord;
    Out.v_FrontColor = u_InnerColor;
    return Out;
}

//=================================================================================================
// Pixel shader
//=================================================================================================

float4 ps_main(PS_IN In) : SV_TARGET
{
	return float4(1.0, 1.0, 1.0, (u_MaterialDiffuseTexture.Sample(u_MaterialDiffuseTextureSampler, In.v_TexCoord).r)) * In.v_FrontColor ;

}
