cbuffer cbGlobal
{
	float4 u_MaterialAmbientColor;
    matrix u_TextureTransformMatrix;
    matrix u_WorldViewProjectionMatrix;
    Texture2D u_MaterialDiffuseTexture;
    SamplerState u_MaterialDiffuseTextureSampler;
};
struct VS_IN
{
    float3 a_Position : POSITION;
    float2 a_TexCoord : TEXCOORD;
    float4 a_Color : COLOR;
};

struct PS_IN
{
    float4 v_Position : SV_POSITION;
	float2 v_TexCoord : TEXCOORD;
    float4 v_FrontColor : COLOR;
};

PS_IN vs_main(VS_IN In)
{
    PS_IN Out;
    Out.v_FrontColor = u_MaterialAmbientColor;
    Out.v_TexCoord = mul(u_TextureTransformMatrix, float4(In.a_TexCoord, 0.0, 1.0)).xy;
    Out.v_Position = mul(u_WorldViewProjectionMatrix, float4(In.a_Position, 1.0));
    return Out;
}

float4 ps_main(PS_IN In) : SV_TARGET
{
    float4 result;
    result = u_MaterialDiffuseTexture.Sample(u_MaterialDiffuseTextureSampler, In.v_TexCoord)*In.v_FrontColor;
    return result;
}